hdu 2377 Bus Pass

Bus Pass

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 667    Accepted Submission(s): 271

Problem Description

You travel a lot by bus and the costs of all the seperate tickets are starting to add up.

Therefore you want to see if it might be advantageous for you to buy a bus pass.

The way the bus system works in your country (and also in the Netherlands) is as follows:

when
you buy a bus pass, you have to indicate a center zone and a star
value. You are allowed to travel freely in any zone which has a distance
to your center zone which is less than your star value. For example, if
you have a star value of one, you can only travel in your center zone.
If you have a star value of two, you can also travel in all adjacent
zones, et cetera.

You have a list of all bus trips you
frequently make, and would like to determine the minimum star value you
need to make all these trips using your buss pass. But this is not
always an easy task. For example look at the following figure:

Here
you want to be able to travel from A to B and from B to D. The best
center zone is 7400, for which you only need a star value of 4. Note
that you do not even visit this zone on your trips!

Input

On the first line an integert(1 <=t<= 100): the number of test cases. Then for each test case:

One
line with two integersnz(2 <=nz<= 9 999) andnr(1 <=nr<=
10): the number of zones and the number of bus trips, respectively.

nz lines starting with two integers idi (1 <= idi <= 9 999) and mzi (1 <= mzi <= 10), a number identifying the i-th zone and the number of zones adjacent to it, followed by mzi integers: the numbers of the adjacent zones.

nr lines starting with one integer mri (1 <= mri <= 20), indicating the number of zones the ith bus trip visits, followed by mri integers: the numbers of the zones through which the bus passes in the order in which they are visited.

All zones are connected, either directly or via other zones.

Output

For each test case:

One
line with two integers, the minimum star value and the id of a center
zone which achieves this minimum star value. If there are multiple
possibilities, choose the zone with the lowest number.

Sample Input

1
17 2
7400 6 7401 7402 7403 7404 7405 7406
7401 6 7412 7402 7400 7406 7410 7411
7402 5 7412 7403 7400 7401 7411
7403 6 7413 7414 7404 7400 7402 7412
7404 5 7403 7414 7415 7405 7400
7405 6 7404 7415 7407 7408 7406 7400
7406 7 7400 7405 7407 7408 7409 7410 7401
7407 4 7408 7406 7405 7415
7408 4 7409 7406 7405 7407
7409 3 7410 7406 7408
7410 4 7411 7401 7406 7409
7411 5 7416 7412 7402 7401 7410
7412 6 7416 7411 7401 7402 7403 7413
7413 3 7412 7403 7414
7414 3 7413 7403 7404
7415 3 7404 7405 7407
7416 2 7411 7412
5 7409 7408 7407 7405 7415
6 7415 7404 7414 7413 7412 7416

Sample Output

4 7400

#include <iostream>
#include <stack>
#include <cstring>
#include <cstdio>
#include <string>
#include <algorithm>
#include <queue>
using namespace std;
/*
要求出某个点到所有公交站点的距离最大的最小;
那么就可以先求出每个公交站点到所有点的距离中,相应的每个点到公交站点的距离取最大,在所有点距离去最小即可。
*/
#define ms(arr, val) memset(arr, val, sizeof(arr))
#define N 10000
#define INF 0x3fffffff
struct node
{
    int seq;
    int lay;
};
int id[N][11];
int idtag[N];
int idmax[N];
int iddis[N];
queue<int> q;

void bfs(int p)//求bfs求单元最短路,因为相邻两点距离为1.
{
    ms(iddis, 0);
    ms(idtag, 0);
    q.push(p);
    idtag[p] = iddis[p] = 1;
    while (!q.empty())
    {
        int s = q.front();
        q.pop();
        int i = 0;
        while (id[s][i])
        {
            if (!idtag[id[s][i]])
            {
                iddis[id[s][i]] = iddis[s] + 1;
                idtag[id[s][i]] = 1;
                q.push(id[s][i]);
            }
            i++;
        }
    }
}
int main()
{
    int t, nz, nr, mzn, idp, mrn, tt, ans, pos;
    cin >> t;
    while (t--)
    {
        ms(id, 0);
        ms(idmax, 0);
        cin >> nz >> nr;
        for (int i = 0; i < nz; i++)
        {
            cin >> idp >> mzn;
            for (int j = 0; j < mzn; j++)
            {
                cin >> id[idp][j];
            }
        }

        for (int i = 0; i < nr; i++)
        {
            cin >> mrn;
            for (int j = 0; j < mrn; j++)
            {
                cin >> tt;
                bfs(tt);
                for (int i = 0; i < N; i++)
                {
                    idmax[i] = max(idmax[i], iddis[i]);
                }
            }
        }
        pos = 0;
        ans = INF;
        for (int i = 0; i < N; i++)
        {
            if (idmax[i] > 0 && ans > idmax[i])
            {
                pos = i;
                ans = idmax[i];
            }
        }
        cout << ans <<‘ ‘<<pos<< endl;
    }
    return 0;
}

hdu 2377 Bus Pass

时间: 2024-08-12 08:41:37

hdu 2377 Bus Pass的相关文章

HDU 2377 Bus Pass spfa

Problem Description You travel a lot by bus and the costs of all the seperate tickets are starting to add up. Therefore you want to see if it might be advantageous for you to buy a bus pass. The way the bus system works in your country (and also in t

Bus Pass

ZOJ Problem Set - 2913 Time Limit: 5 Seconds      Memory Limit: 32768 KB You travel a lot by bus and the costs of all the seperate tickets are starting to add up. Therefore you want to see if it might be advantageous for you to buy a bus pass. The wa

Bus Pass BFS搜索

Bus Pass 题目抽象:给出nz个点组成的连通图,给出每个点的连接顶点.给出nr条路径.要求找出某点,使得到达每条路径上的每个顶点的距离的最大值最小. 分析:以每条路径上的顶点为起点,bfs搜索.具体见代码. 1 /******************************** 2 please don't hack me!! /(ToT)/~~ 3 __------__ 4 /~ ~ 5 | //^\\//^\| 6 /~~\ || T| |T|:~ 7 | |6 ||___|_|_||

hdu 1690 Bus System (最短路径)

Bus System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6082    Accepted Submission(s): 1560 Problem Description Because of the huge population of China, public transportation is very importa

ZOJ 2913 Bus Pass (最近的最远BFS HDU2377)

题意  在所有城市中找一个中心满足这个中心到所有公交站点距离的最大值最小 输出最小距离和满足最小距离编号最小的中心 最基础的BFS  对每个公交站点BFS  dis[i]表示编号为i的点到所有公交站点距离的最大值  bfs完所有站点后  dis[i]最小的点就是要求的点咯 #include<cstdio> #include<cstring> #include<queue> #include<set> using namespace std; typedef

zoj 2913 Bus Pass (BFS)

Bus Pass Time Limit: 5 Seconds      Memory Limit: 32768 KB You travel a lot by bus and the costs of all the seperate tickets are starting to add up. Therefore you want to see if it might be advantageous for you to buy a bus pass. The way the bus syst

Zoj 2913 Bus Pass BFS

题意: 给你一张图,和一些指定的点,找一个点使得这些指定的点到这个点的距离的最大值最小 对每一个指定的点都做一遍BFS,更新到达每个点的距离,取较大值,然后扫一遍所有的点,找出最小即可. 注意:不同于走格子,因为方向比较多,所以要在扩展节点的时候就更新vis数组,不然有可能导致某个点的距离因为重复更新而不是最小值. 并且不要漏了一开始就更新起点的vis #include <cstdio> #include <vector> #include <cstring> #inc

hdu 1690 Bus System(Floyd)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1690 Problem Description Because of the huge population of China, public transportation is very important. Bus is an important transportation method in traditional public transportation system. And it's

HDU 2377 &amp;&amp; ZOJ 2412

~~~~ 输入好长... 思路就是对线路上的每一个点BFS记录各个点到其所需的star值,然后ans记录所需的最大star值,最后输出ans最小的star值及相应的id. 开始建链接矩阵,结果MLE,于是修改了下. 题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=2377 http://acm.zju.edu.cn/onlinejudge/showProblemStatus.do?problemId=1912 ~~~~ #include<iostr